!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: PrintBarCode.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  MEMBER('main.clw')

!---------------------------------------------------------------------------
!
!---------------------------------------------------------------------------
  MAP
    MODULE('MAV SQL')
      INCLUDE('MAVSQL.INC'),ONCE
    END
    MODULE('Printer API')
      pbc_GetLastError(),SIGNED,PASCAL,NAME('GetLastError')
      pbc_OpenPrinter(LONG pPrinterName, *LONG outhPrinter,LONG pDefault),BOOL,PASCAL,RAW,NAME('OpenPrinterA'),PROC
      pbc_StartDocPrinter(LONG hPrinter, LONG Level, LONG pDocInfo),LONG,PASCAL,PROC,RAW,NAME('StartDocPrinterA')
      pbc_EndDocPrinter(LONG hPrinter),BOOL,PASCAL,RAW,PROC,Name('EndDocPrinter')
      pbc_StartPagePrinter(LONG hPrinter),BOOL,PASCAL,RAW,PROC,Name('StartPagePrinter')
      pbc_EndPagePrinter(LONG hPrinter),BOOL,PASCAL,RAW,PROC,Name('EndPagePrinter')
      pbc_WritePrinter(LONG hPrinter, *CSTRING pBuf, LONG cbBuf, *LONG pcBytesWritten),BOOL,RAW,PASCAL,PROC,Name('WritePrinter')
      pbc_ClosePrinter ( LONG hPrinter ),BOOL,RAW,PASCAL,PROC,Name('ClosePrinter')
    END
  END

  INCLUDE('EQUATES.CLW'),ONCE
  INCLUDE('ERRORS.CLW'),ONCE
  INCLUDE('KEYCODES.CLW'),ONCE
  INCLUDE('PrintBarCode.inc'),ONCE

PrintBarCode.Construct         PROCEDURE
  CODE
  SELF.BarCodeQueue &= NEW TBarCodeQueue

PrintBarCode.Destruct          PROCEDURE
  CODE
  FREE(SELF.BarCodeQueue)
  DISPOSE(SELF.BarCodeQueue)

PrintBarCode.Init              PROCEDURE(STRING PrinterName, STRING INIFile)
  CODE
  SELF.PrinterName = CLIP(PrinterName)
  SELF.INIFile = INIFile
  SELF.BarCodeTone = GETINI('Barcode', 'Tone', SELF.BarCodeTone, SELF.INIFile)

PrintBarCode.AddGoods          PROCEDURE(LONG GoodsID, LONG Copyes=1)
  CODE
  MAVCLEAR(Goods)
  G:GoodsID = GoodsID
  Err# = MAVGET(Goods)
  SELF.BarCodeQueue.GoodsID   = GoodsID
  SELF.BarCodeQueue.GoodsName = G:GoodsName
  SELF.BarCodeQueue.Copyes    = Copyes
  ADD(SELF.BarCodeQueue)

PrintBarCode.AddAccount        PROCEDURE(LONG AccountID)
DS                             &IDynStr
GoodsQueue                     QUEUE,PRE(GoodsQueue)
GoodsID                          LONG
GoodsName                        STRING(100)
                               END
  CODE
  DS &= NewDynStr()
  DS.Kill()
  DS.Cat('SELECT ')
  DS.Cat('  AD.GoodsID ')
  DS.Cat('  G.GoodsName ')
  DS.Cat('FROM ')
  DS.Cat('  AccountDetails AD ')
  DS.Cat('  JOIN Goods G ON G.GoodsID = AD.GoodsID ')
  DS.Cat('WHERE ')
  DS.Cat('  AD.AccountID = ' & AccountID)
  IF MAVLOAD(DS.Str(), GoodsQueue)
    MAVSHOWERROR('  !')
  END
  DisposeDynStr(DS)
  LOOP W# = 1 TO RECORDS(GoodsQueue)
    GET(GoodsQueue,W#)
    CLEAR(SELF.BarCodeQueue)
    SELF.BarCodeQueue.GoodsID   = GoodsQueue.GoodsID
    SELF.BarCodeQueue.GoodsName = GoodsQueue.GoodsName
    ADD(SELF.BarCodeQueue)
  END

PrintBarCode.ClearData         PROCEDURE
  CODE
  FREE(SELF.BarCodeQueue)
  CLEAR(SELF.BarCodeQueue)

PrintBarCode.CreateBarcodes    PROCEDURE()!,BYTE,PROC,PRIVATE
DS                             &IDynStr
MExec                          MAVExecute
GoodsQueue                     QUEUE,PRE(GoodsQueue)
GoodsID                          LONG
BarCode                          STRING(13)
                               END
loc:BarCode                    STRING(13)
loc:BarCodeStd                 STRING(13)
loc:BarCodeCustom              STRING(13)
loc:FoundCustom                BYTE
loc:FoundStd                   BYTE
  CODE
  LOOP W# = RECORDS(SELF.BarCodeQueue) TO 1 BY -1
    GET(SELF.BarCodeQueue,W#)
    DS &= NewDynStr()
    DS.Kill()
    DS.Cat(' SELECT ')
    DS.Cat('   GBC.GoodsID, ')
    DS.Cat('   GBC.BarCode ')
    DS.Cat(' FROM ')
    DS.Cat('   GoodsBarcodes GBC ')
    DS.Cat(' WHERE ')
    DS.Cat('   GBC.GoodsID = '&SELF.BarCodeQueue.GoodsID)
    DS.Cat(' ORDER BY ')
    DS.Cat('   GBC.ScanDate DESC ')
    IF MAVLOAD(DS.Str(), GoodsQueue)
      DisposeDynStr(DS)
      MAVSHOWERROR('  ID '&SELF.BarCodeQueue.GoodsID&'  !')
      RETURN TRUE
    END
    DisposeDynStr(DS)

    loc:FoundCustom = FALSE
    loc:FoundStd = FALSE
    loc:BarCode = SELF.GetCCNumber('234060'&FORMAT(SELF.BarCodeQueue.GoodsID,@N06))
    LOOP E# = 1 TO RECORDS(GoodsQueue)
      GET(GoodsQueue,E#)
      IF GoodsQueue.BarCode = loc:BarCode
        loc:FoundCustom = TRUE
        loc:BarCodeCustom = GoodsQueue.BarCode
      ELSE
        loc:FoundStd = TRUE
        loc:BarCodeStd = GoodsQueue.BarCode
        BREAK
      END
    END

    !  
    IF loc:FoundStd
      SELF.BarCodeQueue.BarCode = loc:BarCodeStd
      PUT(SELF.BarCodeQueue)
    !    
    ELSIF ~loc:FoundStd AND ~loc:FoundCustom
      !   
      IF SELF.AllowAdd
        DS &= NewDynStr()
        DS.Kill()
        DS.Cat(' INSERT INTO GoodsBarCodes (BarCode,GoodsID,ScanDate,CreateDateTime,UpdateDateTime,CreateUserCode) VALUES(')
        DS.Cat('   '''&loc:BarCode&''',')
        DS.Cat('   '&SELF.BarCodeQueue.GoodsID&',')
        DS.Cat('   GETDATE(),')
        DS.Cat('   GETDATE(),')
        DS.Cat('   GETDATE(),')
        DS.Cat('   '&GLO:UserID)
        DS.Cat(' ) ')
        IF MExec.Run(DS.Str())
          DisposeDynStr(DS)
          MAVSHOWERROR('    !')
          RETURN TRUE
        END
        DisposeDynStr(DS)
        SELF.BarCodeQueue.BarCode = loc:BarCode
        PUT(SELF.BarCodeQueue)
      ELSE
        !        
        DELETE(SELF.BarCodeQueue)
      END
    !   
    ELSIF loc:FoundCustom
      SELF.BarCodeQueue.BarCode = loc:BarCodeCustom
      PUT(SELF.BarCodeQueue)
    !    
    ELSE
      MESSAGE('   !')
      RETURN TRUE
    END
  END
  RETURN FALSE

PrintBarCode.SetAllowAdd       PROCEDURE(BYTE AllowAdd)
  CODE
  SELF.AllowAdd = AllowAdd

PrintBarCode.PrintData         PROCEDURE
BarCodeString                  CSTRING(1024)
euRub                          STRING(20)
loc:Price                      DECIMAL(15,2)
  CODE
  IF SELF.CreateBarcodes()
    MESSAGE('    !')
    RETURN
  END
  IF RECORDS(SELF.BarCodeQueue) = 0 AND SELF.AllowAdd = 0
    MESSAGE('         !','',ICON:Hand)
    RETURN
  END
  euRub = '.'
  CONVERTANSITOOEM(euRub)
  ! 
  LOOP W# = 1 TO RECORDS(SELF.BarCodeQueue)
    GET(SELF.BarCodeQueue,W#)
    CLEAR(BarCodeString)
    xReplace(SELF.BarCodeQueue.GoodsName,'     ',' ')
    xReplace(SELF.BarCodeQueue.GoodsName,'    ',' ')
    xReplace(SELF.BarCodeQueue.GoodsName,'   ',' ')
    xReplace(SELF.BarCodeQueue.GoodsName,'  ',' ')
    CONVERTANSITOOEM(SELF.BarCodeQueue.GoodsName)

    CASE GLO:BarcodePaperType
    OF 1 ! 22 
      BarCodeString = CLIP(BarCodeString) & '<27>Q032<27>D'&FORMAT(SELF.BarCodeTone,@N1)&'<27>A01<13>'
      ! M15 
      ! A02 
      BarCodeString = CLIP(BarCodeString) & '<27>M15<27>A02'&SUB(SELF.BarCodeQueue.GoodsName,1,26)&'<13>'
      IF CLIP(SUB(SELF.BarCodeQueue.GoodsName,27,24))
        BarCodeString = CLIP(BarCodeString) & '<27>A02'&CENTER(SUB(SELF.BarCodeQueue.GoodsName,27,24),26)&'<13>'
      END
      !  
      IF SELF.PrintWithPrice
        CLEAR(loc:Price)
        IF MAVLOAD('SELECT GPD.Price FROM GoodsPriceDiscount GPD WHERE GPD.GoodsID = ' & SELF.BarCodeQueue.GoodsID, loc:Price)
          MAVSHOWERROR()
        END
        BarCodeString = CLIP(BarCodeString) & '<27>A02'&CENTER(FORMAT(loc:Price,@N15.2)&' '&CLIP(euRub),26)&'<13>'
      END
      BarCodeString = CLIP(BarCodeString) & '<27>?'&CHOOSE(LEN(CLIP(SELF.BarCodeQueue.BarCode))=12,'U','E')&'<27>A12<27>M16<27><123>'&CLIP(SELF.BarCodeQueue.BarCode)&'<125><13>'
      BarCodeString = CLIP(BarCodeString) & '<27>A01'&FORMAT(TODAY(),@D06.)&'    '&SELF.BarCodeQueue.GoodsID&'<13><12>'

    OF 2 ! 27  ()
      BarCodeString = CLIP(BarCodeString) & '<27>Q168<27>D7'
      ! M15 
      ! A02 
      BarCodeString = CLIP(BarCodeString) & '<27>Q168<27>D'&FORMAT(SELF.BarCodeTone,@N1)&CHOOSE(LEN(CLIP(SELF.BarCodeQueue.GoodsName))<=40,'<27>A11<13>','')
      BarCodeString = CLIP(BarCodeString) & '<27>M09<27>A11'&CENTER(SUB(SELF.BarCodeQueue.GoodsName,1,20),20)&'<13>'
      IF CLIP(SUB(SELF.BarCodeQueue.GoodsName,21,20))
        BarCodeString = CLIP(BarCodeString) & '<27>A11'&CENTER(SUB(SELF.BarCodeQueue.GoodsName,21,20),20)&'<13>'
      END
      IF CLIP(SUB(SELF.BarCodeQueue.GoodsName,41,20))
        BarCodeString = CLIP(BarCodeString) & '<27>A11'&CENTER(SUB(SELF.BarCodeQueue.GoodsName,41,20),20)&'<13>'
      END
      !  
      IF SELF.PrintWithPrice
        CLEAR(loc:Price)
        IF MAVLOAD('SELECT GPD.Price FROM GoodsPriceDiscount GPD WHERE GPD.GoodsID = ' & SELF.BarCodeQueue.GoodsID, loc:Price)
          MAVSHOWERROR()
        END
        BarCodeString = CLIP(BarCodeString) & '<27>A11'&CENTER(FORMAT(loc:Price,@N15.2)&' '&CLIP(euRub),20)&'<13>'
      END
      BarCodeString = CLIP(BarCodeString) & '<27>?'&CHOOSE(LEN(CLIP(SELF.BarCodeQueue.BarCode))=12,'U','E')&'<27>A12<27>M16<27><123>'&CLIP(SELF.BarCodeQueue.BarCode)&'<125><13>'
      BarCodeString = CLIP(BarCodeString) & '<27>A01'&FORMAT(TODAY(),@D06.)&'    '&SELF.BarCodeQueue.GoodsID&'<13><12>'
    END

    LOOP SELF.BarCodeQueue.Copyes TIMES
      IF ~SELF.RawDataToPrinter(BarCodeString)
        BREAK
      END
    END
  END
  SELF.ClearData

PrintBarCode.QuickPrint        PROCEDURE(LONG GoodsID)
  CODE
  SELF.PrintWithPrice = TRUE
  SELF.AddGoods(GoodsID, 1)
  SELF.PrintData
  SELF.PrintWithPrice = FALSE

PrintBarCode.PrintData         PROCEDURE(LONG GoodsID, LONG ShopID)
  CODE
  SELF.PrintWithPrice = TRUE
  SELF.ShopID = ShopID
  SELF.PrintData(GoodsID)
  SELF.PrintWithPrice = FALSE

PrintBarCode.PrintData         PROCEDURE(LONG GoodsID)
loc:Count                      LONG(1)
WindowPS WINDOW(' '),AT(,,244,87),FONT('MS Sans Serif',8,,FONT:regular),CENTER,GRAY,DOUBLE
       PANEL,AT(0,0,,28),USE(?PanelInfoBC:123),FULL,FILL(COLOR:White),BEVEL(0,0,09H)
       IMAGE('help2.ico'),AT(4,4),USE(?ImageInfoBC:123)
       STRING('      '),AT(30,10),USE(?StringInfoBC:123), |
           TRN
       PANEL,AT(0,63,,1),USE(?PanelBC:123),FULL,BEVEL(-1,1)
       PROMPT(' '),AT(55,39),USE(?PromptBC:123)
       ENTRY(@N_4),AT(129,39,60,12),USE(loc:Count)
       BUTTON(' '),AT(144,69,48,14),USE(?PrintBCButton),DEFAULT
       BUTTON(''),AT(192,69,48,14),USE(?CancelBCButton)
       BUTTON(''),AT(6,69,48,14),USE(?ConfigBCButton)
     END
  CODE
  OPEN(WindowPS)
  ACCEPT
    CASE ACCEPTED()
    OF ?PrintBCButton
      IF loc:Count
        UPDATE
        SELF.AddGoods(GoodsID, loc:Count)
        SELF.PrintData
        BREAK
      END
    OF ?CancelBCButton
      RETURN
    OF ?ConfigBCButton
      SELF.Config
    END
  END
  CLOSE(WindowPS)

PrintBarCode.Config            PROCEDURE
loc:BarCodeTone                BYTE
WindowPS1 WINDOW('  '),AT(,,244,87),FONT('MS Sans Serif',8,,FONT:regular),CENTER, |
         GRAY,DOUBLE
       PANEL,AT(0,0,,28),USE(?PanelInfoBC:1231),FULL,FILL(COLOR:White),BEVEL(0,0,09H)
       IMAGE('help2.ico'),AT(4,4),USE(?ImageInfoBC:1231)
       STRING('  '),AT(30,10),USE(?StringInfoBC:1231),TRN
       PANEL,AT(0,63,,1),USE(?PanelBC:1231),FULL,BEVEL(-1,1)
       PROMPT('  [0 () - 7 ()]'),AT(38,42),USE(?PromptBC:1231)
       SPIN(@N_1),AT(162,40,27,12),USE(loc:BarCodeTone),LEFT(2),RANGE(0,7),STEP(1)
       BUTTON('OK'),AT(144,69,48,14),USE(?OK1BCButton),DEFAULT
       BUTTON(''),AT(192,69,48,14),USE(?Cancel1BCButton)
     END
  CODE
  loc:BarCodeTone = SELF.BarCodeTone
  OPEN(WindowPS1)
  ACCEPT
    CASE ACCEPTED()
    OF ?OK1BCButton
      UPDATE
      SELF.BarCodeTone = loc:BarCodeTone
      PUTINI('Barcode', 'Tone', SELF.BarCodeTone, SELF.INIFile)
      BREAK
    OF ?Cancel1BCButton
      BREAK
    END
  END
  CLOSE(WindowPS1)

PrintBarCode.GetCCNumber       PROCEDURE(STRING inBarCode)!,STRING
LOC:RetValue                   STRING(100)
LOC:BarcodeSum                 LONG
  CODE
  len# = LEN(CLIP(LEFT(inBarCode)))
  cnt# = 0                                         !   
  LOOP j# = len# TO 1 BY -1                        !   
    cnt# += 1                                      !  /
    IF cnt# % 2                                    ! 
      LOC:BarcodeSum += inBarCode[j#] * 3
    ELSE
      LOC:BarcodeSum += inBarCode[j#]
    END
  END
  loc:BarcodeSum = (10 - (loc:BarcodeSum % 10)) % 10
  loc:RetValue = CLIP(inBarCode)&LOC:BarcodeSum
  RETURN loc:RetValue

PrintBarCode.RawDataToPrinter  PROCEDURE(*CSTRING lpData)!,BYTE
dwCount                        LONG
hPrinter                       LONG
DocInfo                        LIKE(TSA_DOC_INFO_1)
dwJob                          LONG
dwBytesWritten                 LONG
pDocName                       CSTRING(200)
pOutputFile                    CSTRING(200)
pDatatype                      CSTRING(200)
  CODE
  IF CLIP(SELF.PrinterName) = ''
    MESSAGE('     ','',ICON:Hand)
    RETURN FALSE
  END
  dwCount = LEN(lpData)
  !   .
  IF ~pbc_OpenPrinter(ADDRESS(SELF.PrinterName), hPrinter, 0)
    MESSAGE(' '&pbc_GetLastError()& '     ' & CLIP(SELF.PrinterName))
    RETURN FALSE
  END
  !     
  pDocName    = 'Barcode'
  pOutputFile = ''
  pDatatype   = 'RAW'
  DocInfo.pDocName    = ADDRESS(pDocName)
  DocInfo.pOutputFile = ADDRESS(pOutputFile)
  DocInfo.pDatatype   = ADDRESS(pDatatype)
  !    ,    .
  dwJob = pbc_StartDocPrinter(hPrinter, 1, ADDRESS(DocInfo))
  IF dwJob = 0
    pbc_ClosePrinter(hPrinter)
    RETURN FALSE
  END
  !  .
  IF ~pbc_StartPagePrinter(hPrinter)
    pbc_EndDocPrinter(hPrinter)
    pbc_ClosePrinter(hPrinter)
    RETURN FALSE
  END
  !    .
  IF ~pbc_WritePrinter(hPrinter, lpData, dwCount, dwBytesWritten)
    pbc_EndPagePrinter(hPrinter)
    pbc_EndDocPrinter(hPrinter)
    pbc_ClosePrinter(hPrinter)
    RETURN FALSE
  END
  !  .
  IF ~pbc_EndPagePrinter(hPrinter)
    pbc_EndDocPrinter(hPrinter)
    pbc_ClosePrinter(hPrinter)
    RETURN FALSE
  END
  !     .
  IF ~pbc_EndDocPrinter(hPrinter)
    pbc_ClosePrinter(hPrinter)
    RETURN FALSE
  END
  !   .
  pbc_ClosePrinter(hPrinter)
  !     .
  IF dwBytesWritten <> dwCount
    RETURN FALSE
  END
  RETURN TRUE


